(function(publish){function JsRiveObjects(master){this._master=master;this._objects={};};JsRiveObjects.prototype.load=function(name,code){var source="this._objects[\""+name+"\"] = function (rs, args) {\n"
+code.join("\n")
+"}\n";try{eval(source);}catch(e){this._master.warn("Error evaluating JavaScript object: "+e.message);}};JsRiveObjects.prototype.call=function(rs,name,fields,scope){var func=this._objects[name];var reply="";try{reply=func.call(scope,rs,fields);}catch(e){reply="[ERR: Error when executing JavaScript object]";}
return reply;};var VERSION="1.01";var RS_VERSION="2.0";function RiveScript(opts){this._debug=false;this._strict=true;this._depth=50;this._div=undefined;this._node={};this._runtime=this.runtime();this._pending=[];this._loadcount=0;this._gvars={};this._bvars={};this._subs={};this._person={};this._arrays={};this._users={};this._freeze={};this._includes={};this._lineage={};this._handlers={};this._objlangs={};this._topics={};this._thats={};this._sorted={};if(typeof(opts)=="object"){if(opts["debug"]){this._debug=opts["debug"]?true:false;}
if(opts["strict"]){this._strict=opts["strict"]?true:false;}
if(opts["depth"]){this._depth=parseInt(opts["depth"]);}
if(opts["debug_div"]){this._div=opts["debug_div"];if(this._div.indexOf("#")!=0){this._div="#"+this._div;}}}
this._handlers["javascript"]=new JsRiveObjects(this);this.say("RiveScript Interpreter v"+VERSION+" Initialized.");this.say("Runtime Environment: "+this._runtime);}
RiveScript.prototype.version=function(){return VERSION;}
RiveScript.prototype.runtime=function(){if(!Object.keys){this._shim_keys();}
if(typeof(window)=="undefined"&&typeof(module)=="object"){this._node["fs"]=require("fs");return"node";}else{return"web";}};RiveScript.prototype.say=function(message){if(this._debug!=true){return;}
if(this._div){$(this._div).append("<div>[RS] "+this._escape_html(message)+"</div>");}else if(console&&console.log){console.log("[RS] "+message);}};RiveScript.prototype.warn=function(message,fname,lineno){if(typeof(fname)!="undefined"&&typeof(lineno)!="undefined"){message+=" at "+fname+" line "+lineno;}
if(this._div){$(this._div).append("<div style='color: #FF0000; font-weight: bold'>"
+this._escape_html(message)+"</div>");}else if(console){if(console.error){console.error(message);}else if(console.log){console.log("[WARNING] "+message);}}else{window.alert(message);}}
RiveScript.prototype.loadFile=function(path,on_success,on_error){if(typeof(path)=="string"){path=[path];}
var loadcount=this._loadcount++;this._pending[loadcount]={};for(var i=0;i<path.length;i++){var file=path[i];this.say("Request to load file: "+file);this._pending[loadcount][file]=1;if(this._runtime=="web"){this._ajax_load_file(loadcount,file,on_success,on_error);}else if(this._runtime=="node"){this._node_load_file(loadcount,file,on_success,on_error);}}
return loadcount;};RiveScript.prototype._ajax_load_file=function(loadcount,file,on_success,on_error){var RS=this;$.ajax({url:file,dataType:"text",success:function(data,textStatus,xhr){RS.say("Loading file "+file+" complete.");RS.parse(file,data,on_error);delete RS._pending[loadcount][file];if(Object.keys(RS._pending[loadcount]).length==0){if(typeof(on_success)=="function"){on_success.call(undefined,loadcount);}}},error:function(xhr,textStatus,errorThrown){RS.say("Error! "+textStatus+"; "+errorThrown);if(typeof(on_error)=="function"){on_error.call(undefined,loadcount,textStatus);}},});};RiveScript.prototype._node_load_file=function(loadcount,file,on_success,on_error){var RS=this;this._node.fs.readFile(file,function(err,data){if(err){if(typeof(on_error)=="function"){on_error.call(undefined,loadcount,err);}else{RS.warn(err);}
return;}
RS.parse(file,""+data,on_error);delete RS._pending[loadcount][file];if(Object.keys(RS._pending[loadcount]).length==0){if(typeof(on_success)=="function"){on_success.call(undefined,loadcount);}}});};RiveScript.prototype.loadDirectory=function(path,on_success,on_error){if(this._runtime==="web"){this.warn("loadDirectory can't be used on the web!");return;}
var loadcount=this._loadcount++;this._pending[loadcount]={};var RS=this;this._node.fs.readdir(path,function(err,files){if(err){if(typeof(on_error)=="function"){on_error.call(undefined,err);}else{RS.warn(error);}
return;}
var to_load=[];for(var i=0,iend=files.length;i<iend;i++){if(files[i].match(/\.rs$/i)){RS._pending[loadcount][path+"/"+files[i]]=1;to_load.push(path+"/"+files[i]);}}
for(var i=0,iend=to_load.length;i<iend;i++){var file=to_load[i];RS._node_load_file(loadcount,to_load[i],on_success,on_error);}});};RiveScript.prototype.stream=function(code,on_error){this.say("Streaming code.");return this.parse("stream()",code,on_error);};RiveScript.prototype.parse=function(fname,code,on_error){this.say("Parsing code!");var topic="random";var lineno=0;var comment=false;var inobj=false;var objname="";var objlang="";var objbuf=[];var ontrig="";var repcnt=0;var concnt=0;var lastcmd="";var isThat="";var lines=code.split("\n");for(var lp=0,ll=lines.length;lp<ll;lp++){var line=lines[lp];lineno=lp+1;line=this._strip(line);if(line.length==0){continue;}
if(inobj){if(line.indexOf("< object")>-1){if(objname.length>0){if(this._handlers[objlang]){this._objlangs[objname]=objlang;this._handlers[objlang].load(objname,objbuf);}else{this.warn("Object creation failed: no handler for "+objlang,fname,lineno);}}
objname='';objlang='';objbuf='';inobj=false;}else{objbuf.push(line);}
continue;}
if(line.indexOf("//")==0){continue;}else if(line.indexOf("#")==0){this.warn("Using the # symbol for comments is deprecated",fname,lineno);continue;}else if(line.indexOf("/*")==0){if(line.indexOf("*/")>-1){continue;}
comment=true;continue;}else if(line.indexOf("*/")>-1){comment=false;continue;}
if(comment){continue;}
if(line.length<2){this.warn("Weird single-character line '"+line+"' found",fname,lineno);continue;}
cmd=line.substring(0,1);line=this._strip(line.substring(1));if(line.indexOf(" // ")>-1){line=this._strip(line.split(" // ")[0]);}
var syntax_error=this.checkSyntax(cmd,line);if(syntax_error!=""){if(this._strict&&typeof(on_error)=="function"){on_error.call(null,"Syntax error: "+syntax_error
+" at "+fname+" line "+lineno
+", near "+cmd+" "+line);return false;}else{this.warn("Syntax error: "+syntax_error);}}
if(cmd=='+'){isThat="";}
for(var i=lp+1;i<ll;i++){var lookahead=this._strip(lines[i]);if(lookahead.length<2){continue;}
var lookCmd=lookahead.substring(0,1);lookahead=this._strip(lookahead.substring(1));if(lookahead.length!=0){if(lookCmd!='^'&&lookCmd!='%'){break;}
if(cmd=='+'){if(lookCmd=='%'){isThat=lookahead;break;}else{isThat='';}}
if(cmd=='!'){if(lookCmd=='^'){line+="<crlf>"+lookahead;}
continue;}
if(cmd!='^'&&lookCmd!='%'){if(lookCmd=='^'){line+=lookahead;}else{break;}}}}
this.say("Cmd: '"+cmd+"'; line: "+line);switch(cmd){case'!':var halves=line.split("=",2);var left=this._strip(halves[0]).split(" ",2);var value=type=name='';if(halves.length==2){value=this._strip(halves[1]);}
if(left.length>=1){type=this._strip(left[0]);if(left.length>=2){left.shift();name=this._strip(left.join(" "));}}
if(type!="array"){value=value.replace(/<crlf>/g,"");}
if(type=="version"){if(parseFloat(value)>parseFloat(RS_VERSION)){this.warn("Unsupported RiveScript version. We only support "+RS_VERSION,fname,lineno);return false;}
continue;}
if(name.length==0){this.warn("Undefined variable name",fname,lineno);continue;}else if(value.length==0){this.warn("Undefined variable value",fname,lineno);continue;}
if(type=="global"){this.say("Set global "+name+" = "+value);if(value=="<undef>"){delete this._gvars[name];continue;}else{this._gvars[name]=value;}
if(name=="debug"){if(value.toLowerCase()=="true"){this._debug=true;}else{this._debug=false;}}else if(name=="depth"){this._depth=parseInt(value);}else if(name=="strict"){if(value.toLowerCase()=="true"){this._strict=true;}else{this._strict=false;}}}else if(type=="var"){this.say("Set bot variable "+name+" = "+value);if(value=="<undef>"){delete this._bvars[name];}else{this._bvars[name]=value;}}else if(type=="array"){this.say("Set array "+name+" = "+value);if(value=="<undef>"){delete this._arrays[name];continue;}
var parts=value.split("<crlf>");var fields=[];for(var i=0,end=parts.length;i<end;i++){var val=parts[i];if(val.indexOf("|")>-1){var tmp=val.split("|");fields.push.apply(fields,val.split("|"));}else{fields.push.apply(fields,val.split(" "));}}
for(var i=0,end=fields.length;i<end;i++){fields[i]=fields[i].replace(/\\s/ig," ");}
this._arrays[name]=fields;}else if(type=="sub"){this.say("Set substitution "+name+" = "+value);if(value=="<undef>"){delete this._subs[name];}else{this._subs[name]=value;}}else if(type=="person"){this.say("Set person substitution "+name+" = "+value);if(value=="<undef>"){delete this._person[name];}else{this._person[name]=value;}}else{this.warn("Unknown definition type '"+type+"'",fname,lineno);}
continue;case'>':var temp=this._strip(line).split(" ");var type=temp.shift();this.say("line: "+line+"; temp: "+temp+"; type: "+type);var name='';var fields=[];if(temp.length>0){name=temp.shift();}
if(temp.length>0){fields=temp;}
if(type=="begin"){this.say("Found the BEGIN block.");type="topic";name="__begin__";}
if(type=="topic"){this.say("Set topic to "+name);ontrig='';topic=name;var mode='';if(fields.length>=2){for(var i=0;i<fields.length;i++){var field=fields[i];if(field=="includes"||field=="inherits"){mode=field;}else if(mode!=''){if(mode=="includes"){if(!this._includes[name]){this._includes[name]={};}
this._includes[name][field]=1;}else{if(!this._lineage[name]){this._lineage[name]={};}
this._lineage[name][field]=1;}}}}}else if(type=="object"){lang=undefined;if(fields.length>0){lang=fields[0].toLowerCase();}
ontrig='';if(lang==undefined){self.warn("Trying to parse unknown programming language",fname,lineno);lang='javascript';}
if(this._handlers[lang]){objname=name;objlang=lang;objbuf=[];inobj=true;}else{objname='';objlang='';objbuf=[];inobj=true;}}else{this.warn("Unknown label type '"+type+"'",fname,lineno);}
continue;case'<':var type=line;if(type=="begin"||type=="topic"){this.say("End the topic label.");topic="random";}else if(type=="object"){this.say("End the object label.");inobj=false;}
continue;case'+':this.say("Trigger pattern: "+line);if(isThat.length>0){this._initTT('thats',topic,isThat,line);}else{this._initTT('topics',topic,line);}
ontrig=line;repcnt=0;concnt=0;continue;case'-':if(ontrig==''){this.warn("Response found before trigger",fname,lineno);continue;}
this.say("Response: "+line);if(isThat.length>0){this._thats[topic][isThat][ontrig]['reply'][repcnt]=line;}else{this._topics[topic][ontrig]['reply'][repcnt]=line;}
repcnt++;continue;case'%':continue;case'^':continue;case'@':this.say("Redirect response to: "+line);if(isThat.length>0){this._thats[topic][isThat][ontrig]['redirect']=this._strip(line);}else{this._topics[topic][ontrig]['redirect']=this._strip(line);}
continue;case'*':this.say("Adding condition: "+line);if(isThat.length>0){this._thats[topic][isThat][ontrig]['condition'][concnt]=line;}else{this._topics[topic][ontrig]['condition'][concnt]=line;}
concnt++;continue;default:this.warn("Unknown command '"+cmd+"'",fname,lineno);}}
return true;};RiveScript.prototype.checkSyntax=function(cmd,line){if(cmd=='!'){var match=line.match(/^.+(?:\s+.+|)\s*=\s*.+?$/);if(!match){return"Invalid format for !Definition line: must be '! type name = value' OR '! type = value'";}}else if(cmd=='>'){var parts=line.split(/\s+/);if(parts[0]=="begin"&&parts.length>1){return"The 'begin' label takes no additional arguments.";}else if(parts[0]=="topic"){var match=line.match(/[^a-z0-9_\-\s]/);if(match){return"Topics should be lowercased and contain only letters and numbers.";}}else if(parts[0]=="object"){var match=line.match(/[^A-Za-z0-9\_\-\s]/);if(match){return"Objects can only contain numbers and letters.";}}}else if(cmd=='+'||cmd=='%'||cmd=='@'){var parens=square=curly=angle=0;if(line.match(/[^a-z0-9(|)\[\]*_#@{}<>=\s]/)){return"Triggers may only contain lowercase letters, numbers, and these symbols: ( | ) [ ] * _ # @ { } < > =";}
var chars=line.split("");for(var i=0,end=chars.length;i<end;i++){switch(chars[i]){case'(':parens++;continue;case')':parens--;continue;case'[':square++;continue;case']':square--;continue;case'{':curly++;continue;case'}':curly--;continue;case'<':angle++;continue;case'>':angle--;continue;}}
if(parens!=0){return"Unmatched parenthesis brackets.";}else if(square!=0){return"Unmatched square brackets.";}else if(curly!=0){return"Unmatched curly brackets.";}else if(angle!=0){return"Unmatched angle brackets.";}}else if(cmd=='*'){var match=line.match(/^.+?\s*(?:==|eq|!=|ne|<>|<|<=|>|>=)\s*.+?=>.+?$/);if(!match){return"Invalid format for !Condition: should be like '* value symbol value => response'";}}
return"";};RiveScript.prototype._initTT=function(toplevel,topic,trigger,what){if(toplevel=="topics"){if(!this._topics[topic]){this._topics[topic]={};}
if(!this._topics[topic][trigger]){this._topics[topic][trigger]={'reply':{},'condition':{},'redirect':undefined};}}else if(toplevel=="thats"){if(!this._thats[topic]){this._thats[topic]={};}
if(!this._thats[topic][trigger]){this._thats[topic][trigger]={};}
if(!this._thats[topic][trigger][what]){this._thats[topic][trigger][what]={'reply':{},'condition':{},'redirect':undefined};}}};RiveScript.prototype.sortReplies=function(thats){var triglvl,sortlvl;if(thats!=undefined){triglvl=this._thats;sortlvl='thats';}else{triglvl=this._topics;sortlvl='topics';}
this._sorted[sortlvl]={};this.say("Sorting triggers...");for(var topic in triglvl){this.say("Analyzing topic "+topic);var alltrig=this._topic_triggers(topic,triglvl);var running=this._sort_trigger_set(alltrig);if(!this._sorted[sortlvl]){this._sorted[sortlvl]={};}
this._sorted[sortlvl][topic]=running;}
if(thats==undefined){this.sortReplies(true);this._sort_that_triggers();this._sort_list("subs",Object.keys(this._subs));this._sort_list("person",Object.keys(this._person));}};RiveScript.prototype._sort_that_triggers=function(){this.say("Sorting reverse triggers for %Previous groups...");this._sorted["that_trig"]={};for(var topic in this._thats){if(!this._sorted["that_trig"][topic]){this._sorted["that_trig"][topic]={};}
for(var bottrig in this._thats[topic]){if(!this._sorted["that_trig"][topic][bottrig]){this._sorted["that_trig"][topic][bottrig]=[];}
var triggers=this._sort_trigger_set(Object.keys(this._thats[topic][bottrig]));this._sorted["that_trig"][topic][bottrig]=triggers;}}};RiveScript.prototype._sort_trigger_set=function(triggers){var prior={0:[]};for(var i=0,end=triggers.length;i<end;i++){var trig=triggers[i];var match=trig.match(/\{weight=(\d+)\}/i);var weight=0;if(match&&match[1]){weight=match[1];}
if(!prior[weight]){prior[weight]=[];}
prior[weight].push(trig);}
var running=[];var prior_sort=Object.keys(prior).sort(function(a,b){return b-a});for(var i=0,end=prior_sort.length;i<end;i++){var p=prior_sort[i];this.say("Sorting triggers with priority "+p);var inherits=-1;var highest_inherits=-1;var track={};track[inherits]=this._init_sort_track();for(var j=0,jend=prior[p].length;j<jend;j++){var trig=prior[p][j];this.say("Looking at trigger: "+trig);var match=trig.match(/\{inherits=(\d+)\}/i);if(match&&match[1]){inherits=parseInt(match[1]);if(inherits>highest_inherits){highest_inherits=inherits;}
this.say("Trigger belongs to a topic that inherits other topics. Level="+inherits);trig=trig.replace(/\{inherits=\d+\}/ig,"");}else{inherits=-1;}
if(!track[inherits]){track[inherits]=this._init_sort_track();}
if(trig.indexOf("_")>-1){var cnt=this._word_count(trig);this.say("Has a _ wildcard with "+cnt+" words.");if(cnt>1){if(!track[inherits]['alpha'][cnt]){track[inherits]['alpha'][cnt]=[];}
track[inherits]['alpha'][cnt].push(trig);}else{track[inherits]['under'].push(trig);}}
else if(trig.indexOf("#")>-1){var cnt=this._word_count(trig);this.say("Has a # wildcard with "+cnt+" words.");if(cnt>1){if(!track[inherits]['number'][cnt]){track[inherits]['number'][cnt]=[];}
track[inherits]['number'][cnt].push(trig);}else{track[inherits]['pound'].push(trig);}}
else if(trig.indexOf("*")>-1){var cnt=this._word_count(trig);this.say("Has a * wildcard with "+cnt+" words.");if(cnt>1){if(!track[inherits]['wild'][cnt]){track[inherits]['wild'][cnt]=[];}
track[inherits]['wild'][cnt].push(trig);}else{track[inherits]['star'].push(trig);}}
else if(trig.indexOf("[")>-1){var cnt=this._word_count(trig);this.say("Has optionals with "+cnt+" words.");if(!track[inherits]['option'][cnt]){track[inherits]['option'][cnt]=[];}
track[inherits]['option'][cnt].push(trig);}
else{var cnt=this._word_count(trig);this.say("Totally atomic trigger and "+cnt+" words.");if(!track[inherits]['atomic'][cnt]){track[inherits]['atomic'][cnt]=[];}
track[inherits]['atomic'][cnt].push(trig);}}
track[(highest_inherits+1)]=track['-1'];delete track['-1'];var track_sorted=Object.keys(track).sort(function(a,b){return a-b});for(var j=0,jend=track_sorted.length;j<jend;j++){var ip=track_sorted[j];this.say("ip="+ip);var kinds=["atomic","option","alpha","number","wild"];for(var k=0,kend=kinds.length;k<kend;k++){var kind=kinds[k];var kind_sorted=Object.keys(track[ip][kind]).sort(function(a,b){return b-a});for(var l=0,lend=kind_sorted.length;l<lend;l++){var item=kind_sorted[l];running.push.apply(running,track[ip][kind][item]);}}
var under_sorted=track[ip]['under'].sort(function(a,b){return b.length-a.length});var pound_sorted=track[ip]['pound'].sort(function(a,b){return b.length-a.length});var star_sorted=track[ip]['star'].sort(function(a,b){return b.length-a.length});running.push.apply(running,under_sorted);running.push.apply(running,pound_sorted);running.push.apply(running,star_sorted);}}
return running;};RiveScript.prototype._sort_list=function(name,items){if(!this._sorted["lists"]){this._sorted["lists"]={};}
this._sorted["lists"][name]=[];var track={};for(var i=0,end=items.length;i<end;i++){var cnt=this._word_count(items[i],true);if(!track[cnt]){track[cnt]=[];}
track[cnt].push(items[i]);}
var output=[];var sorted=Object.keys(track).sort(function(a,b){return b-a});for(var i=0,end=sorted.length;i<end;i++){var count=sorted[i];var bylen=track[count].sort(function(a,b){return b.length-a.length});output.push.apply(output,bylen);}
this._sorted["lists"][name]=output;};RiveScript.prototype._init_sort_track=function(){return{'atomic':{},'option':{},'alpha':{},'number':{},'wild':{},'pound':[],'under':[],'star':[]};};RiveScript.prototype.setHandler=function(lang,obj){if(obj==undefined){delete this._handlers[lang];}else{this._handlers[lang]=obj;}};RiveScript.prototype.setSubroutine=function(name,code){if(this._handlers["javascript"]){this._handlers["javascript"]._objects[name]=code;}else{this.warn("Can't setSubroutine: no JavaScript object handler is loaded!");}};RiveScript.prototype.setGlobal=function(name,value){if(value==undefined){delete this._gvars[name];}else{this._gvars[name]=value;}};RiveScript.prototype.setVariable=function(name,value){if(value==undefined){delete this._bvars[name];}else{this._bvars[name]=value;}};RiveScript.prototype.setSubstitution=function(name,value){if(value==undefined){delete this._subs[name];}else{this._subs[name]=value;}};RiveScript.prototype.setPerson=function(name,value){if(value==undefined){delete this._person[name];}else{this._person[name]=value;}};RiveScript.prototype.setUservar=function(user,name,value){if(!this._users[user]){this._users[user]={"topic":"random"};}
if(value==undefined){delete this._users[user][name];}else{this._users[user][name]=value;}};RiveScript.prototype.getUservar=function(user,name){if(!this._users[user]){return"undefined";}
if(this._users[user][name]){return this._users[user][name];}else{return"undefined";}};RiveScript.prototype.getUservars=function(user){if(user==undefined){return $.extend(true,{},this._users);}else{if(this._users[user]){return $.extend(true,{},this._users[user]);}else{return undefined;}}};RiveScript.prototype.clearUservars=function(user){if(user==undefined){this._users={};}else{delete this._users[user];}};RiveScript.prototype.freezeUservars=function(user){if(this._users[user]){this._freeze[user]=$.extend(true,{},this._users[user]);}else{this.warn("Can't freeze vars for user "+user+": not found!");}};RiveScript.prototype.thawUservars=function(user,action){if(typeof(action)!="string"){action="thaw";}
if(!this._freeze[user]){this.warn("Can't thaw user vars: "+user+" not found!");return;}
if(action=="thaw"){this.clearUservars(user);this._users[user]=$.extend(true,{},this._freeze[user]);delete this._freeze[user];}else if(action=="discard"){delete this._freeze[user];}else if(action=="keep"){this.clearUservars(user);this._users[user]=$.extend(true,{},this._freeze[user]);}else{this.warn("Unsupported thaw action");}};RiveScript.prototype.lastMatch=function(user){if(this._users[user]){return this._users[user]["__lastmatch__"];}
return undefined;};RiveScript.prototype.reply=function(user,msg,scope){this.say("Asked to reply to ["+user+"] "+msg);msg=this._format_message(msg);var reply='';if(this._topics["__begin__"]){var begin=this._getreply(user,"request","begin",0,scope);if(begin.indexOf("{ok}")>-1){reply=this._getreply(user,msg,"normal",0,scope);begin=begin.replace(/\{ok\}/g,reply);}
reply=begin;reply=this._process_tags(user,msg,reply,[],[],0,scope);}else{reply=this._getreply(user,msg,"normal",0,scope);}
this._users[user]["__history__"]["input"].pop();this._users[user]["__history__"]["input"].unshift(msg);this._users[user]["__history__"]["reply"].pop();this._users[user]["__history__"]["reply"].unshift(reply);return reply;};RiveScript.prototype._format_message=function(msg){msg=""+msg;msg=msg.toLowerCase();msg=this._substitute(msg,"subs");msg=this._strip_nasties(msg);return msg;};RiveScript.prototype._getreply=function(user,msg,context,step,scope){if(!this._sorted["topics"]){this.warn("You forgot to call sortReplies()!");return"ERR: Replies Not Sorted";}
if(!this._users[user]){this._users[user]={'topic':'random'};}
var topic=this._users[user]['topic'];var stars=[];var thatstars=[];var reply='';if(!this._topics[topic]){this.warn("User "+user+" was in an empty topic named '"+topic+"'");topic=this._users[user]['topic']='random';}
if(step>this._depth){return"ERR: Deep Recursion Detected";}
if(context=="begin"){topic="__begin__";}
if(!this._users[user]['__history__']){this._users[user]['__history__']={'input':['undefined','undefined','undefined','undefined','undefined','undefined','undefined','undefined','undefined','undefined'],'reply':['undefined','undefined','undefined','undefined','undefined','undefined','undefined','undefined','undefined','undefined'],};}
if(!this._topics[topic]){return"ERR: No default topic 'random' was found!";}
var matched=null;var matchedTrigger=null;var foundMatch=false;if(step==0){var allTopics=[topic];if(this._includes[topic]||this._lineage[topic]){allTopics=this._get_topic_tree(topic);}
for(var i=0,iend=allTopics.length;i<iend;i++){var top=allTopics[i];this.say("Checking topic "+top+" for any %Previous's.");if(this._sorted["thats"][top]){this.say("There's a %Previous in this topic!");var lastReply=this._users[user]["__history__"]["reply"][0];lastReply=this._format_message(lastReply);this.say("Last reply: "+lastReply);for(var j=0,jend=this._sorted["thats"][top].length;j<jend;j++){var trig=this._sorted["thats"][top][j];var botside=this._reply_regexp(user,trig);this.say("Try to match lastReply ("+lastReply+") to "+botside);var match=lastReply.match(new RegExp('^'+botside+'$'));if(match){this.say("Bot side matched!");thatstars=[];for(var k=1,kend=match.length;k<kend;k++){thatstars.push(match[k]);}
for(var k=0,kend=this._sorted["that_trig"][top][trig].length;k<kend;k++){var subtrig=this._sorted["that_trig"][top][trig][k];var humanside=this._reply_regexp(user,subtrig);this.say("Now try to match "+msg+" to "+humanside);match=msg.match(new RegExp("^"+humanside+"$"));if(match){this.say("Found a match!");matched=this._thats[top][trig][subtrig];matchedTrigger=subtrig;foundMatch=true;stars=[];if(match.length>1){for(var j=1,jend=match.length;j<jend;j++){stars.push(match[j]);}}
break;}}}
if(foundMatch){break;}}}
if(foundMatch){break;}}}
if(!foundMatch){this.say("Searching their topic for a match...");for(var i=0,iend=this._sorted["topics"][topic].length;i<iend;i++){var trig=this._sorted["topics"][topic][i];var regexp=this._reply_regexp(user,trig);this.say("Try to match \""+msg+"\" against "+trig+" ("+regexp+")");var isAtomic=this._is_atomic(trig);var isMatch=false;if(isAtomic){if(msg==regexp){isMatch=true;}}else{var match=msg.match(new RegExp('^'+regexp+'$'));if(match){isMatch=true;stars=[];if(match.length>1){for(var j=1,jend=match.length;j<jend;j++){stars.push(match[j]);}}}}
if(isMatch){this.say("Found a match!");if(!this._topics[topic][trig]){matched=this._find_trigger_by_inheritence(topic,trig,0);}else{matched=this._topics[topic][trig];}
foundMatch=true;matchedTrigger=trig;break;}}}
this._users[user]["__lastmatch__"]=matchedTrigger;if(matched){for(var nil=0;nil<1;nil++){if(matched["redirect"]){this.say("Redirecting us to '"+matched["redirect"]+"'");var redirect=this._process_tags(user,msg,matched["redirect"],stars,thatstars,step,scope);this.say("Pretend user said: "+redirect);reply=this._getreply(user,redirect,context,(step+1),scope);break;}
for(var i=0;matched["condition"][i];i++){var halves=matched["condition"][i].split(/\s*=>\s*/);if(halves&&halves.length==2){var condition=halves[0].match(/^(.+?)\s+(==|eq|!=|ne|<>|<|<=|>|>=)\s+(.+?)$/);if(condition){var left=this._strip(condition[1]);var eq=condition[2];var right=this._strip(condition[3]);var potreply=this._strip(halves[1]);left=this._process_tags(user,msg,left,stars,thatstars,step,scope);right=this._process_tags(user,msg,right,stars,thatstars,step,scope);if(left.length==0){left="undefined";}
if(right.length==0){right="undefined";}
this.say("Check if "+left+" "+eq+" "+right);var passed=false;if(eq=="eq"||eq=="=="){if(left==right){passed=true;}}else if(eq=="ne"||eq=="!="||eq=="<>"){if(left!=right){passed=true;}}else{try{left=parseInt(left);right=parseInt(right);if(eq=="<"){if(left<right){passed=true;}}else if(eq=="<="){if(left<=right){passed=true;}}else if(eq==">"){if(left>right){passed=true;}}else if(eq==">="){if(left>=right){passed=true;}}}catch(e){this.warn("Failed to evaluate numeric condition!");}}
if(passed){reply=potreply;break;}}}}
if(reply!=undefined&&reply.length>0){break;}
var bucket=[];for(var rep_index in matched["reply"]){var rep=matched["reply"][rep_index];var weight=1;var match=rep.match(/\{weight=(\\d+?)\}/i);if(match){weight=match[1];if(weight<=0){this.warn("Can't have a weight <= 0!");weight=1;}}
for(var j=0;j<weight;j++){bucket.push(rep);}}
var choice=parseInt(Math.random()*bucket.length);reply=bucket[choice];break;}}
if(!foundMatch){reply="ERR: No Reply Matched";}else if(reply==undefined||reply.length==0){reply="ERR: No Reply Found";}
this.say("Reply: "+reply);if(context=="begin"){var giveup=0;var match=reply.match(/\{topic=(.+?)\}/i);while(match){giveup++;if(giveup>=50){this.warn("Infinite loop looking for topic tag!");break;}
var name=match[1];this._users[user]["topic"]=name;reply=reply.replace(new RegExp("{topic="+this.quotemeta(name)+"}","ig"),"");match=reply.match(/\{topic=(.+?)\}/i);}
match=reply.match(/<set (.+?)=(.+?)>/i);giveup=0;while(match){giveup++;if(giveup>=50){this.warn("Infinite loop looking for set tag!");break;}
var name=match[1];var value=match[2];this._users[user][name]=value;}}else{reply=this._process_tags(user,msg,reply,stars,thatstars,step,scope);}
return reply;};RiveScript.prototype._reply_regexp=function(user,regexp){regexp=regexp.replace(/^\*$/,"<zerowidthstar>");regexp=regexp.replace(/\*/g,"(.+?)");regexp=regexp.replace(/#/g,"(\\d+?)");regexp=regexp.replace(/_/g,"([A-Za-z]+?)");regexp=regexp.replace(/\{weight=\d+\}/g,"");regexp=regexp.replace(/<zerowidthstar>/g,"(.*?)");var match=regexp.match(/\[(.+?)\]/);var giveup=0;while(match){giveup++;if(giveup>=50){this.warn("Infinite loop when trying to process optionals in trigger!");return"";}
var parts=match[1].split("|");var opts=[];for(var i=0,iend=parts.length;i<iend;i++){var p="\\s*"+parts[i]+"\\s*";opts.push(p);}
opts.push("\\s*");var pipes=opts.join("|");pipes=pipes.replace(new RegExp(this.quotemeta("(.+?)"),"g"),"(?:.+?)");pipes=pipes.replace(new RegExp(this.quotemeta("(\\d+?)"),"g"),"(?:\\d+?)");pipes=pipes.replace(new RegExp(this.quotemeta("([A-Za-z]+?)"),"g"),"(?:[A-Za-z]+?)");regexp=regexp.replace(new RegExp("\\s*\\["+this.quotemeta(match[1])+"\\]\\s*"),"(?:"+pipes+")");match=regexp.match(/\[(.+?)\]/);}
var giveup=0;while(regexp.indexOf("@")>-1){giveup++;if(giveup>=50){break;}
var match=regexp.match(/\@(.+?)\b/);if(match){var name=match[1];var rep='';if(this._arrays[name]){rep="(?:"+this._arrays[name].join("|")+")";}
regexp=regexp.replace(new RegExp("@"+this.quotemeta(name)+"\\b"),rep);}}
giveup=0;while(regexp.indexOf("<bot")>-1){giveup++;if(giveup>=50){break;}
var match=regexp.match(/<bot (.+?)>/i);if(match){var name=match[1];var rep='';if(this._bvars[name]){rep=this._strip_nasties(this._bvars[name]);}
regexp=regexp.replace(new RegExp("<bot "+this.quotemeta(name)+">"),rep);}}
var match=regexp.match(/<get (.+?)>/i);giveup=0;while(match){giveup++;if(giveup>=50){this.warn("Infinite loop looking for get tag!");break;}
var name=match[1];var value="undefined";if(this._users[user][name]){value=this._users[user][name];}
regexp=regexp.replace(new RegExp("<get "+this.quotemeta(name)+">","ig"),value);match=regexp.match(/<get (.+?)>/i);}
if(regexp.indexOf("<input")>-1||regexp.indexOf("<reply")>-1){var types=["input","reply"];for(var i=0;i<2;i++){var type=types[i];for(var j=1;j<=9;j++){if(regexp.indexOf("<"+type+j+">")){regexp=regexp.replace(new RegExp("<"+type+j+">","g"),this._users[user]["__history__"][type][j]);}}
regexp=regexp.replace(new RegExp("<"+type+">","g"),this._users[user]["__history__"][type][0]);}}
return regexp;};RiveScript.prototype._process_tags=function(user,msg,reply,st,bst,step,scope){var stars=[""];stars.push.apply(stars,st);var botstars=[""];botstars.push.apply(botstars,bst);if(stars.length==1){stars.push("undefined");}
if(botstars.length==1){botstars.push("undefined");}
var match;var giveup=0;reply=reply.replace(/<person>/ig,"{person}<star>{/person}");reply=reply.replace(/<@>/ig,"{@<star>}");reply=reply.replace(/<formal>/ig,"{formal}<star>{/formal}");reply=reply.replace(/<sentence>/ig,"{sentence}<star>{/sentence}");reply=reply.replace(/<uppercase>/ig,"{uppercase}<star>{/uppercase}");reply=reply.replace(/<lowercase>/ig,"{lowercase}<star>{/lowercase}");reply=reply.replace(/\{weight=\d+\}/ig,"");reply=reply.replace(/<star>/ig,stars[1]);reply=reply.replace(/<botstar>/ig,botstars[1]);for(var i=1;i<=stars.length;i++){reply=reply.replace(new RegExp("<star"+i+">","ig"),stars[i]);}
for(var i=1;i<=botstars.length;i++){reply=reply.replace(new RegExp("<botstar"+i+">","ig"),botstars[i]);}
reply=reply.replace(/<input>/ig,this._users[user]["__history__"]["input"][0]);reply=reply.replace(/<reply>/ig,this._users[user]["__history__"]["reply"][0]);for(var i=1;i<=9;i++){if(reply.indexOf("<input"+i+">")){reply=reply.replace(new RegExp("<input"+i+">","ig"),this._users[user]["__history__"]["input"][i]);}
if(reply.indexOf("<reply"+i+">")){reply=reply.replace(new RegExp("<reply"+i+">","ig"),this._users[user]["__history__"]["reply"][i]);}}
reply=reply.replace(/<id>/ig,user);reply=reply.replace(/\\s/ig," ");reply=reply.replace(/\\n/ig,"\n");reply=reply.replace(/\\#/ig,"#");match=reply.match(/\{random\}(.+?)\{\/random\}/i);giveup=0;while(match){giveup++;if(giveup>50){this.warn("Infinite loop looking for random tag!");break;}
var random=[];var text=match[1];if(text.indexOf("|")>-1){random=text.split("|");}else{random=text.split(" ");}
var output=random[parseInt(Math.random()*random.length)];reply=reply.replace(new RegExp("\\{random\\}"+this.quotemeta(text)+"\\{\\/random\\}","ig"),output);match=reply.match(/\{random\}(.+?)\{\/random\}/i);}
var formats=["person","formal","sentence","uppercase","lowercase"];for(var i=0;i<5;i++){var type=formats[i];match=reply.match(new RegExp("{"+type+"}(.+?){/"+type+"}","i"));giveup=0;while(match){giveup++;if(giveup>=50){this.warn("Infinite loop looking for "+type+" tag!");break;}
var content=match[1];var replace;if(type=="person"){replace=this._substitute(content,"person");}else{replace=this._string_format(type,content);}
reply=reply.replace(new RegExp("{"+type+"}"+this.quotemeta(content)+"{/"+type+"}","ig"),replace);match=reply.match(new RegExp("{"+type+"}(.+?){/"+type+"}","i"));}}
match=reply.match(/<bot ([^>]+?)=([^>]+?)>/i);giveup=0;while(match){giveup++;if(giveup>=50){this.warn("Infinite loop looking for bot set tag!");break;}
var name=match[1];var value=match[2];this._bvars[name]=value;reply=reply.replace(new RegExp("<bot "+this.quotemeta(name)+"="+this.quotemeta(value)+">","ig"),"");match=reply.match(/<bot ([^>]+?)=([^>]+?)>/i);}
match=reply.match(/<bot ([^>]+?)>/i);giveup=0;while(match){giveup++;if(giveup>=50){this.warn("Infinite loop looking for bot tag!");break;}
var name=match[1];var value="undefined";if(this._bvars[name]){value=this._bvars[name];}
reply=reply.replace(new RegExp("<bot "+this.quotemeta(name)+">","ig"),value);match=reply.match(/<bot ([^>]+?)>/i);}
match=reply.match(/<env ([^>]+?)=([^>]+?)>/i);giveup=0;while(match){giveup++;if(giveup>=50){this.warn("Infinite loop looking for env set tag!");break;}
var name=match[1];var value=match[2];this._gvars[name]=value;reply=reply.replace(new RegExp("<env "+this.quotemeta(name)+"="+this.quotemeta(value)+">","ig"),"");match=reply.match(/<env ([^>]+?)=([^>]+?)>/i);}
match=reply.match(/<env ([^>]+?)>/i);giveup=0;while(match){giveup++;if(giveup>=50){this.warn("Infinite loop looking for env tag!");break;}
var name=match[1];var value="undefined";if(this._gvars[name]){value=this._gvars[name];}
reply=reply.replace(new RegExp("<env "+this.quotemeta(name)+">","ig"),value);match=reply.match(/<env ([^>]+?)>/i);}
match=reply.match(/<set ([^>]+?)=([^>]+?)>/i);giveup=0;while(match){giveup++;if(giveup>=50){this.warn("Infinite loop looking for set tag!");break;}
var name=match[1];var value=match[2];this._users[user][name]=value;reply=reply.replace(new RegExp("<set "+this.quotemeta(name)+"="+this.quotemeta(value)+">","ig"),"");match=reply.match(/<set ([^>]+?)=([^>]+?)>/i);}
var math=["add","sub","mult","div"];for(var i=0;i<4;i++){var oper=math[i];match=reply.match(new RegExp("<"+oper+" ([^>]+?)=([^>]+?)>"));giveup=0;while(match){var name=match[1];var value=match[2];var newval=0;var output="";value=parseInt(value);if(isNaN(value)){output="[ERR: Math can't '"+oper+"' non-numeric value '"+match[2]+"']";}else if(isNaN(parseInt(this._users[user][name]))){output="[ERR: Math can't '"+oper+"' non-numeric user variable '"+name+"']";}else{var orig=parseInt(this._users[user][name]);if(oper=="add"){newval=orig+value;}else if(oper=="sub"){newval=orig-value;}else if(oper=="mult"){newval=orig*value;}else if(oper=="div"){if(value==0){output="[ERR: Can't Divide By Zero]";}else{newval=orig/value;}}}
if(output==""){this._users[user][name]=newval;}
reply=reply.replace(new RegExp("<"+oper+" "+this.quotemeta(name)+"="+this.quotemeta(""+value)+">","i"),output);match=reply.match(new RegExp("<"+oper+" ([^>]+?)=([^>]+?)>"));}}
match=reply.match(/<get (.+?)>/i);giveup=0;while(match){giveup++;if(giveup>=50){this.warn("Infinite loop looking for get tag!");break;}
var name=match[1];var value="undefined";if(this._users[user][name]){value=this._users[user][name];}
reply=reply.replace(new RegExp("<get "+this.quotemeta(name)+">","ig"),value);match=reply.match(/<get (.+?)>/i);}
match=reply.match(/\{topic=(.+?)\}/i);giveup=0;while(match){giveup++;if(giveup>=50){this.warn("Infinite loop looking for topic tag!");break;}
var name=match[1];this._users[user]["topic"]=name;reply=reply.replace(new RegExp("{topic="+this.quotemeta(name)+"}","ig"),"");match=reply.match(/\{topic=(.+?)\}/i);}
match=reply.match(/\{@(.+?)\}/);giveup=0;while(match){giveup++;if(giveup>=50){this.warn("Infinite loop looking for redirect tag!");break;}
var target=this._strip(match[1]);this.say("Inline redirection to: "+target);var subreply=this._getreply(user,target,"normal",step+1,scope);reply=reply.replace(new RegExp("\\{@"+this.quotemeta(target)+"\\}","i"),subreply);match=reply.match(/\{@(.+?)\}/);}
match=reply.match(/<call>(.+?)<\/call>/i);giveup=0;while(match){giveup++;if(giveup>=50){this.warn("Infinite loop looking for call tag!");break;}
var text=this._strip(match[1]);var parts=text.split(/\s+/);var obj=parts[0];var args=[];for(var i=1,iend=parts.length;i<iend;i++){args.push(parts[i]);}
var output="";if(this._objlangs[obj]){var lang=this._objlangs[obj];if(this._handlers[lang]){output=this._handlers[lang].call(this,obj,args,scope);}else{output="[ERR: No Object Handler]";}}else{output="[ERR: Object Not Found]";}
reply=reply.replace(new RegExp("<call>"+this.quotemeta(match[1])+"</call>","i"),output);match=reply.match(/<call>(.+?)<\/call>/i);}
return reply;};RiveScript.prototype._substitute=function(msg,list){if(!this._sorted["lists"]||!this._sorted["lists"][list]){this.warn("You forgot to call sortReplies()!");return"";}
var subs;if(list=="subs"){subs=this._subs;}else{subs=this._person;}
var notword="([^A-Za-z0-9])";notword="(\\W+)";for(var i=0,end=this._sorted["lists"][list].length;i<end;i++){var pattern=this._sorted["lists"][list][i];var result="<rot13sub>"+this._rot13(subs[pattern])+"<bus31tor>";var qm=this.quotemeta(pattern);msg=msg.replace(new RegExp("^"+qm+"$","g"),result);msg=msg.replace(new RegExp("^"+qm+"(\\W+)","g"),result+"$1");msg=msg.replace(new RegExp("(\\W+)"+qm+"(\\W+)","g"),"$1"+result+"$2");msg=msg.replace(new RegExp("(\\W+)"+qm+"$","g"),"$1"+result);}
var tries=0;while(msg.indexOf("<rot13sub>")>-1){tries++;if(tries>50){this.warn("Too many loops!");break;}
var match=msg.match("<rot13sub>(.+?)<bus31tor>");if(match){var cap=match[1];var decoded=this._rot13(cap);msg=msg.replace(new RegExp("<rot13sub>"+this.quotemeta(cap)+"<bus31tor>","g"),decoded);}else{this.warn("Unknown fatal error! Saw a <rot13sub> but the regexp to find it failed!");return"";}}
return msg;};RiveScript.prototype._is_atomic=function(trigger){var special=['*','#','_','(','[','<'];for(var i=0,end=special.length;i<end;i++){if(trigger.indexOf(special[i])>-1){return false;}}
return true;};RiveScript.prototype._topic_triggers=function(topic,triglvl,depth,inheritence,inherited){if(depth==undefined){depth=0;}
if(inheritence==undefined){inheritence=0;}
if(inherited==undefined){inherited=0;}
if(depth>this._depth){this.warn("Deep recursion while scanning topic inheritence!");return;}
this.say("Collecting trigger list for topic "+topic+" (depth="
+depth+"; inheritence="+inheritence+"; inherited="+inherited
+")");var triggers=[];var inThisTopic=[];if(triglvl[topic]){for(var trigger in triglvl[topic]){inThisTopic.push(trigger);}}
if(this._includes[topic]){for(var includes in this._includes[topic]){this.say("Topic "+topic+" includes "+includes);triggers.push.apply(triggers,this._topic_triggers(includes,triglvl,(depth+1),(inheritence+1),true));}}
if(this._lineage[topic]){for(var inherits in this._lineage[topic]){this.say("Topic "+topic+" inherits "+inherits);triggers.push.apply(triggers,this._topic_triggers(inherits,triglvl,(depth+1),(inheritence+1),false));}}
if(this._lineage[topic]||inherited){for(var i=0,end=inThisTopic.length;i<end;i++){var trigger=inThisTopic[i];this.say("Prefixing trigger with {inherits="+inheritence+"}"+trigger);triggers.push.apply(triggers,["{inherits="+inheritence+"}"+trigger]);}}else{triggers.push.apply(triggers,inThisTopic);}
return triggers;};RiveScript.prototype._find_trigger_by_inheritence=function(topic,trig,depth){if(depth>this._depth){this.warn("Deep recursion detected while following an inheritence trail!");return undefined;}
if(this._lineage[topic]){for(var inherits in this._lineage[topic]){if(this._topics[inherits][trig]){return this._topics[inherits][trig];}else{var match=this._find_trigger_by_inheritence(inherits,trig,(depth+1));if(match){return match;}}}}
if(this._includes[topic]){for(var includes in this._includes[topic]){if(this._topics[includes][trig]){return this._topics[includes][trig];}else{var match=this._find_trigger_by_inheritence(includes,trig,(depth+1));if(match){return match;}}}}
this.warn("User matched a trigger, "+trig+", but I can't find out what topic it belongs to!");return undefined;};RiveScript.prototype._get_topic_tree=function(topic,depth){if(typeof(depth)!="number"){depth=0;}
if(depth>this._depth){this.warn("Deep recursion while scanning topic tree!");return[];}
var topics=[topic];if(this._includes[topic]){for(var includes in this._includes[topic]){topics.push.apply(topics,this._get_topic_tree(includes,depth+1));}}
if(this._lineage[topic]){for(var inherits in this._lineage[topic]){topics.push.apply(topics,this._get_topic_tree(inherits,depth+1));}}
return topics;};RiveScript.prototype._strip=function(text){text=text.replace(/^[\s\t]+/i,"");text=text.replace(/[\s\t]+$/i,"");text=text.replace(/[\x0D\x0A]+/i,"");return text;};RiveScript.prototype._word_count=function(trigger,all){var words=[];if(all){words=trigger.split(/\s+/);}else{words=trigger.split(/[\s\*\#\_\|]+/);}
var wc=0;for(var i=0,end=words.length;i<end;i++){if(words[i].length>0){wc++;}}
return wc;};RiveScript.prototype.quotemeta=function(string){var unsafe="\\.+*?[^]$(){}=!<>|:";for(var i=0,end=unsafe.length;i<end;i++){string=string.replace(new RegExp("\\"+unsafe.charAt(i),"g"),"\\"+unsafe.charAt(i));}
return string;};RiveScript.prototype._rot13=function(string){var result='';for(var i=0,end=string.length;i<end;i++){var b=string.charCodeAt(i);if(b>=65&&b<=77){b+=13;}else if(b>=97&&b<=109){b+=13;}else if(b>=78&&b<=90){b-=13;}else if(b>=110&&b<=122){b-=13;}
result+=String.fromCharCode(b);}
return result;};RiveScript.prototype._string_format=function(type,string){if(type=="uppercase"){return string.toUpperCase();}else if(type=="lowercase"){return string.toLowerCase();}else if(type=="sentence"){string+="";var first=string.charAt(0).toUpperCase();return first+string.substring(1);}else if(type=="formal"){var words=string.split(/\s+/);for(var i=0;i<words.length;i++){var first=words[i].charAt(0).toUpperCase();words[i]=first+words[i].substring(1);}
return words.join(" ");}
return string;};RiveScript.prototype._strip_nasties=function(string){string=string.replace(/[^A-Za-z0-9 ]/g,"");return string;};RiveScript.prototype._escape_html=function(string){string=string.replace(/&/g,"&amp;");string=string.replace(/</g,"&lt;");string=string.replace(/>/g,"&gt;");string=string.replace(/"/g,"&quot;");return string;};RiveScript.prototype._shim_keys=function(){window.alert("Creating Object.keys!");if(!Object.keys){Object.keys=(function(){var hasOwnProperty=Object.prototype.hasOwnProperty,hasDontEnumBug=!({toString:null}).propertyIsEnumerable('toString'),dontEnums=['toString','toLocaleString','valueOf','hasOwnProperty','isPrototypeOf','propertyIsEnumerable','constructor'],dontEnumsLength=dontEnums.length;return function(obj){if(typeof(obj)!=='object'&&typeof(obj)!=='function'||obj==null)throw new TypeError('Object.keys called on non-object');var result=[];for(var prop in obj){if(hasOwnProperty.call(obj,prop)){result.push(prop);}}
if(hasDontEnumBug){for(var i=0;i<dontEnumsLength;i++){if(hasOwnProperty.call(obj,dontEnums[i])){result.push(dontEnums[i]);}}}
return result;}})();}};publish(RiveScript);})((typeof(module)=="undefined"&&(typeof(window)!="undefined"&&this==window))?function(a){this["RiveScript"]=a;}:function(a){module.exports=a;});